// Copyright 2013 SNCF. All rights reserved.
package com.sncf.checker.bo;

import com.sncf.checker.io.FillDAO;
import com.sncf.checker.io.GateDAO;
import com.sncf.checker.io.TrainCategoryDAO;

/**
 * Maintenance facility.
 *
 * @author YDS
 *
 */
public class Facility extends IndividualTrack {

    /**
     * Constructor.
     */
    public Facility() {
        super();
    }

    /**
     * lazy-loading version constructor.
     *
     * @param occupationDAO
     * @param fillDAO
     */
    public Facility(final GateDAO gateDAO, final FillDAO fillDAO, final TrainCategoryDAO categoryDAO) {
        super(gateDAO, fillDAO, categoryDAO);
    }

    /** type of facility. */
    private String type;

    /**
     * Get the type of facility.
     *
     * @return potential reset, "D" if distance, "T" if time
     */
    public final String getType() {
        return type;
    }

    /**
     * Set the type of facility.
     *
     * @return type, "D" if distance, "T" if time
     */
    public final void setType(final String type) {
        this.type = type;
    }
}
