// Copyright 2013 SNCF. All rights reserved.
package com.sncf.checker.io;

import java.util.List;

import com.sncf.checker.bo.Arrival;

/**
 * Data Access Object interface to arrival.
 *
 * @author YDS
 *
 */
public interface ArrivalDAO {

    /**
     * Load an arrival by name.
     *
     * @param name the searched arrival name
     * @return arrival, null if not found
     */
    Arrival loadByName(final String name);

    /**
     * Load an arrival by train name.
     *
     * @param name the searched train name
     * @return arrival, null if not found
     */
    Arrival loadByTrain(final String name);

    /**
     * Load all arrivals.
     *
     * @return arrrival list
     */
    List<Arrival> loadAll();
}
