// Copyright 2013 SNCF. All rights reserved.
package com.sncf.checker.io;

import java.util.ArrayList;
import java.util.List;

import com.sncf.checker.bo.IndividualTrack;

public class IndividualTrackFlatFileDAO implements IndividualTrackDAO {

    /**
     * Constructor.
     *
     * @param scenario file path to the scenario zip archive
     * @param solution file path to the solution file
     */
    public IndividualTrackFlatFileDAO(final String scenario, final String solution) {
    }

    /** Platform DAO. */
    private PlatformDAO platformDAO;

    /**
     * Platform DAO setter.
     *
     * @param dao Platform DAO
     */
    public void setPlatformDAO(final PlatformDAO dao) {
        this.platformDAO = dao;
    }

    /** SingleTrack DAO. */
    private SingleTrackDAO singleTrackDAO;

    /**
     * SingleTrack DAO setter.
     *
     * @param dao SingleTrack DAO
     */
    public void setSingleTrackDAO(final SingleTrackDAO dao) {
        this.singleTrackDAO = dao;
    }

    /** MaintenanceFacility DAO. */
    private MaintenanceFacilityDAO maintenanceFacilityDAO;

    /**
     * MaintenanceFacility DAO setter.
     *
     * @param dao MaintenanceFacility DAO
     */
    public void setMaintenanceFacilityDAO(final MaintenanceFacilityDAO dao) {
        this.maintenanceFacilityDAO = dao;
    }

    /**
     * Load a resource track by name.
     *
     * @param name the searched resource name
     * @return resource object, null if not found
     */
    public IndividualTrack loadByName(final String name) {
        IndividualTrack entity = null;

        entity = maintenanceFacilityDAO.loadByName(name);
        if (entity != null) {
            return entity;
        }
        entity = singleTrackDAO.loadByName(name);
        if (entity != null) {
            return entity;
        }
        entity = platformDAO.loadByName(name);
        if (entity != null) {
            return entity;
        }
        return entity;
    }

    /**
     * Load all resource.
     *
     * @return resource list
     */
    public List<IndividualTrack> loadAll() {
        ArrayList<IndividualTrack> list = new ArrayList<IndividualTrack>();

        list.addAll(maintenanceFacilityDAO.loadAll());
        list.addAll(singleTrackDAO.loadAll());
        list.addAll(platformDAO.loadAll());
        return list;
    }

}
