// Copyright 2013 SNCF. All rights reserved.
package com.sncf.checker.io;

import java.util.List;

import com.sncf.checker.bo.TrackGroup;

/**
 * Data Access Object interface to track group.
 *
 * @author YDS
 *
 */
public interface TrackGroupDAO {

    /**
     * load a track group by name.
     *
     * @return track group, null if not found
     */
    TrackGroup loadByName(final String name);

    /**
     * Load all track groups.
     *
     * @return track group list
     */
    List<TrackGroup> loadAll();
}
