// Copyright 2013 SNCF. All rights reserved.
package com.sncf.checker.io;

import java.util.List;

import com.sncf.checker.bo.TrainCategory;

/**
 * Data Access Object interface to train category.
 *
 * @author YDS
 *
 */
public interface TrainCategoryDAO {

    /**
     * load a train category by name.
     *
     * @param name category's name
     * @return train category, null if not found
     */
    TrainCategory loadByName(final String name);

    /**
     * load the compatible category's list by departure name.
     *
     * @param name departure's name
     * @return train category, null if not found
     */
    List<TrainCategory> loadByDeparture(final String name);

    /**
     * load the compatible category's list by resource name.
     *
     * @param name resource's name
     * @return train category, null if not found
     */
    List<TrainCategory> loadByResource(final String name);
}
