// Copyright 2013 SNCF. All rights reserved.
package com.sncf.checker.io;

import java.util.List;

import com.sncf.checker.bo.Train;

/**
 * Data Access Object interface to train.
 *
 * @author YDS
 *
 */
public interface TrainDAO {

    /**
     * Load a train by name.
     *
     * @param name the searched train name
     * @return train, null if not found
     */
    Train loadByName(final String name);

    /**
     * Load all trains.
     *
     * @return train list
     */
    List<Train> loadAll();
}
